- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FCDAsset Class Reference
[COLLADA Document Object Model.]

A COLLADA asset declaration structure. More...

`#include <FCDAsset.h>`

Inheritance diagram for FCDAsset:

List of all members.

## Public Member Functions
| DeclareFlag (HasUpAxis, 0)
| Whether an up-axis is set for this asset.
| DeclareFlag (HasUnits, 1)
| Whether a length unit is set for this asset.
| DeclareFlagCount (2)
| FCDAsset declares two flags.
| FCDAsset (FCDocument *document)
| Constructor.
virtual | ~FCDAsset ()
| Destructor.
const FCDAssetContributor ** | GetContributors () const
| Retrieves the list of contributors to this asset. See above.
size_t | GetContributorCount () const
| Retrieves the number of contributors to this asset.
FCDAssetContributor * | GetContributor (size_t index)
| Retrieves a contributor tied to this asset.
const FCDAssetContributor * | GetContributor (size_t index) const
| See above.
FCDAssetContributor * | AddContributor ()
| Inserts a new contributor to this asset.
const FUDateTime & | GetCreationDateTime () const
| Retrieves the creation date-time of the document.
FUDateTime & | GetCreationDateTime ()
| [INTERNAL] Use this function to createDateTime when you are writing an import plug-in.
const FUDateTime & | GetModifiedDateTime () const
| Retrieves the last modification date-time of the document.
FUDateTime & | GetModifiedDateTime ()
| [INTERNAL] Use this function to retieve the modifiedDateTime when you are writing an import plug-in.
const fstring & | GetKeywords () const
| Retrieves the list of keywords identifying this asset.
void | SetKeywords (const fstring &_keywords)
| Sets the list of keywords for this asset.
const fstring & | GetRevision () const
| Retrieves the revision string for this asset.
void | SetRevision (const fstring &_revision)
| Sets the revision string for this asset.
const fstring & | GetSubject () const
| Retrieves the subject of the asset.
void | SetSubject (const fstring &_subject)
| Sets the subject of the asset.
const fstring & | GetTitle () const
| Retrieves the title of the asset.
void | SetTitle (const fstring &_title)
| Sets the title of the asset.
const FMVector3 & | GetUpAxis () const
| Retrieves the up-axis of the asset.
void | SetUpAxis (const FMVector3 &_upAxis)
| Sets the up-axis of the asset.
const fstring & | GetUnitName () const
| Retrieves the name of the length unit for the asset.
void | SetUnitName (const fstring &_unitName)
| Sets the name of the length unit for the asset.
float | GetUnitConversionFactor () const
| Retrieves the length unit conversion factor, in meters, for the asset.
void | SetUnitConversionFactor (float factor)
| Sets the length unit conversion factor for the asset.
| DEPRECATED (3.05A, GetHasUpAxisFlag) inline bool HasUpAxis() const
| Retrieves whether an up-axis is set for this asset.
| DEPRECATED (3.05A, GetHasUnitsFlag) inline bool HasUnits() const
| Retrieves whether a length unit is set for this asset.
| DEPRECATED (3.05A, ResetHasUpAxisFlag) inline void ResetUpAxis()
| Resets the up-axis of the asset.
| DEPRECATED (3.05A, ResetHasUnitsFlag) inline void ResetUnits()
| Resets the length unit of the asset.
FCDAsset * | Clone (FCDAsset *clone=NULL, bool cloneAllContributors=true) const
| Clones the asset structure into another asset structure.

## Detailed Description

A COLLADA asset declaration structure.

In COLLADA, there are three types of assets. FCollada recognizes two.

1) The COLLADA document is the most important asset and an asset declaration structure is always created for it. 2) The FCDEntity objects may also contain assets structures. 3) COLLADA also allows asset structure on entity libraries, but FCollada does not support them.

Every asset contains its own list of contributors. Every COLLADA application and conditioner that modifies an asset should attach its signature, in the form of a contributor, to the asset.

See also:
  FCDAssetContributor

## Constructor & Destructor Documentation

FCDAsset::FCDAsset | ( | FCDocument * | document | ) |

  | Constructor. Parameters:
  | document | The COLLADA document that owns the asset.

## Member Function Documentation

FCDAssetContributor* FCDAsset::AddContributor | ( |  | ) |

| Inserts a new contributor to this asset. Returns: An empty contributor structure.

FCDAsset* FCDAsset::Clone | ( | FCDAsset * | clone = `NULL`,
|  | bool | cloneAllContributors = `true`
| ) | const

  | Clones the asset structure into another asset structure. Parameters:
  | clone | The asset structure that will become the copy of this asset. When this pointer is NULL, a new asset structure will be created.
  | cloneAllContributors | Whether all the contributors of this asset should be copied into the clone.
Returns: The clone.

FCDAsset::DeclareFlag | ( | HasUnits | ,
|  | 1 |
| ) |

| Whether a length unit is set for this asset. If no length unit is set for this asset, you should use the length unit of the parent's asset.

FCDAsset::DeclareFlag | ( | HasUpAxis | ,
|  | 0 |
| ) |

| Whether an up-axis is set for this asset. If no up-axis is set for this asset, you should use the up-axis of the parent's asset.

FCDAsset::DEPRECATED | ( | 3. | 05A,
|  | ResetHasUnitsFlag |
| ) | `[inline]`

| Resets the length unit of the asset. The parent asset length unit should henceforth be used. Changing the length unit of an asset does not modify its data.

FCDAsset::DEPRECATED | ( | 3. | 05A,
|  | ResetHasUpAxisFlag |
| ) | `[inline]`

| Resets the up-axis of the asset. The parent asset up-axis should henceforth be used. Changing the up-axis of an asset does not modify its data.

FCDAsset::DEPRECATED | ( | 3. | 05A,
|  | GetHasUnitsFlag |
| ) | const`[inline]`

| Retrieves whether a length unit is set for this asset. If no length unit is set for this asset, you should use the length unit of the parent's asset. Returns: Whether this asset defines a length unit.

FCDAsset::DEPRECATED | ( | 3. | 05A,
|  | GetHasUpAxisFlag |
| ) | const`[inline]`

| Retrieves whether an up-axis is set for this asset. If no up-axis is set for this asset, you should use the up-axis of the parent's asset. Returns: Whether this asset defines an up-axis.

FCDAssetContributor* FCDAsset::GetContributor | ( | size_t | index | ) | `[inline]`

  | Retrieves a contributor tied to this asset. Parameters:
  | index | The index of the contributor.
Returns: The contributor at the given index.

size_t FCDAsset::GetContributorCount | ( |  | ) | const`[inline]`

| Retrieves the number of contributors to this asset. Returns: The number of contributors.

const FCDAssetContributor** FCDAsset::GetContributors | ( |  | ) | const`[inline]`

| Retrieves the list of contributors to this asset. See above. Returns: The list of contributors.

FUDateTime& FCDAsset::GetCreationDateTime | ( |  | ) | `[inline]`

| [INTERNAL] Use this function to createDateTime when you are writing an import plug-in. see above

const FUDateTime& FCDAsset::GetCreationDateTime | ( |  | ) | const`[inline]`

| Retrieves the creation date-time of the document. This date-time is not modifiable. It is set automatically when FCollada creates the document or imported when FCollada reads in a COLLADA document. Returns: The date-time at which the COLLADA document was originally created.

const fstring& FCDAsset::GetKeywords | ( |  | ) | const`[inline]`

| Retrieves the list of keywords identifying this asset. Returns: The list of keywords for the asset.

FUDateTime& FCDAsset::GetModifiedDateTime | ( |  | ) | `[inline]`

| [INTERNAL] Use this function to retieve the modifiedDateTime when you are writing an import plug-in. see above

const FUDateTime& FCDAsset::GetModifiedDateTime | ( |  | ) | const`[inline]`

| Retrieves the last modification date-time of the document. This date-time is not modifiable. It is set automatically when FCollada writes out a COLLADA document to a file, when FCollada creates an original document and when FCollada reads in a COLLADA document from a file. Returns: The date-time at which the COLLADA document was last modified.

const fstring& FCDAsset::GetRevision | ( |  | ) | const`[inline]`

| Retrieves the revision string for this asset. COLLADA doesn't define a standard for the revisions of assets. Returns: The revision string for the asset.

const fstring& FCDAsset::GetSubject | ( |  | ) | const`[inline]`

| Retrieves the subject of the asset. Returns: The subject of the asset.

const fstring& FCDAsset::GetTitle | ( |  | ) | const`[inline]`

| Retrieves the title of the asset. Returns: The title of the asset.

float FCDAsset::GetUnitConversionFactor | ( |  | ) | const`[inline]`

| Retrieves the length unit conversion factor, in meters, for the asset. The length unit of two entities within the same document may differ. To avoid issues with length unit differences, it is suggested that you use the FCDocumentTools::StandardizeUpAxisAndLength function. Returns: The length unit conversion factor.

const fstring& FCDAsset::GetUnitName | ( |  | ) | const`[inline]`

| Retrieves the name of the length unit for the asset. Returns: The name of the length unit for the asset.

const FMVector3& FCDAsset::GetUpAxis | ( |  | ) | const`[inline]`

| Retrieves the up-axis of the asset. The up-axis of two entities within the same document may differ. To avoid issues with up-axis differences, it is suggested that you use the FCDocumentTools::StandardizeUpAxisAndLength function. Returns: The up-axis of the asset.

void FCDAsset::SetKeywords | ( | const fstring & | _keywords | ) | `[inline]`

  | Sets the list of keywords for this asset. Parameters:
  | _keywords | The list of keywords for the asset.

void FCDAsset::SetRevision | ( | const fstring & | _revision | ) | `[inline]`

  | Sets the revision string for this asset. COLLADA doesn't define a standard for the revisions of assets. Parameters:
  | _revision | The revision string for the asset.

void FCDAsset::SetSubject | ( | const fstring & | _subject | ) | `[inline]`

  | Sets the subject of the asset. Parameters:
  | _subject | The subject of the asset.

void FCDAsset::SetTitle | ( | const fstring & | _title | ) | `[inline]`

  | Sets the title of the asset. Parameters:
  | _title | The title of the asset.

void FCDAsset::SetUnitConversionFactor | ( | float | factor | ) | `[inline]`

  | Sets the length unit conversion factor for the asset. Changing the length unit conversion factor of an asset does not modify its data. Parameters:
  | factor | The new length unit conversion factor.

void FCDAsset::SetUnitName | ( | const fstring & | _unitName | ) | `[inline]`

  | Sets the name of the length unit for the asset. Parameters:
  | _unitName | The name of the length unit for the asset.

void FCDAsset::SetUpAxis | ( | const FMVector3 & | _upAxis | ) | `[inline]`

  | Sets the up-axis of the asset. Changing the up-axis of an asset does not modify its data. Parameters:
  | _upAxis | The up-axis of the asset.

The documentation for this class was generated from the following file:

- FCDocument/FCDAsset.h